package dev.shadowsoffire.apotheosis.ench.table;

import net.minecraft.util.random.WeightedEntry;
import net.minecraft.client.gui.components.AbstractSliderButton;
import net.minecraft.network.chat.Style;
import net.minecraft.world.item.enchantment.EnchantmentInstance;
import dev.shadowsoffire.apotheosis.ench.EnchModule;
import java.util.Iterator;
import java.util.Set;
import java.util.stream.Collector;
import java.util.stream.Collectors;
import net.minecraft.client.resources.sounds.SoundInstance;
import net.minecraft.core.Holder;
import net.minecraft.client.resources.sounds.SimpleSoundInstance;
import net.minecraft.sounds.SoundEvents;
import net.minecraft.client.Minecraft;
import com.mojang.blaze3d.vertex.PoseStack;
import net.minecraft.util.random.WeightedRandom;
import java.util.Locale;
import java.util.ArrayList;
import net.minecraft.client.resources.language.I18n;
import net.minecraft.client.gui.GuiGraphics;
import net.minecraft.client.gui.components.events.GuiEventListener;
import net.minecraft.util.Mth;
import java.util.HashMap;
import java.util.Collections;
import net.minecraft.network.chat.Component;
import net.minecraft.world.item.enchantment.Enchantment;
import java.util.Map;
import java.util.List;
import net.minecraft.world.item.ItemStack;
import net.minecraft.ChatFormatting;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.client.gui.screens.Screen;

public class EnchantingInfoScreen extends Screen
{
    public static final ResourceLocation TEXTURES;
    protected static ChatFormatting[] colors;
    protected final ApothEnchantScreen parent;
    protected final int imageWidth;
    protected final int imageHeight;
    protected final ItemStack toEnchant;
    protected final int[] costs;
    protected final int[] clues;
    protected final int[][] powers;
    protected final boolean treasure;
    protected int selectedSlot;
    protected int leftPos;
    protected int topPos;
    protected PowerSlider slider;
    protected int currentPower;
    protected float scrollOffs;
    protected boolean scrolling;
    protected int startIndex;
    List<EnchantmentDataWrapper> enchantments;
    Map<Enchantment, List<Enchantment>> exclusions;
    
    public EnchantingInfoScreen(final ApothEnchantScreen parent) {
        super((Component)Component.m_237115_("info.apotheosis.enchinfo_title"));
        this.powers = new int[3][];
        this.selectedSlot = -1;
        this.enchantments = Collections.emptyList();
        this.exclusions = new HashMap<Enchantment, List<Enchantment>>();
        this.parent = parent;
        this.imageWidth = 240;
        this.imageHeight = 170;
        this.toEnchant = parent.getMenu().m_38853_(0).m_7993_();
        this.costs = parent.getMenu().f_39446_;
        this.clues = parent.getMenu().f_39447_;
        this.treasure = parent.getMenu().stats.treasure();
        for (int i = 0; i < 3; ++i) {
            final Enchantment clue = Enchantment.m_44697_(this.clues[i]);
            if (clue != null) {
                final int level = this.costs[i];
                final float quanta = parent.getMenu().stats.quanta() / 100.0f;
                final float rectification = parent.getMenu().stats.rectification() / 100.0f;
                final int minPow = Math.round(Mth.m_14036_(level - level * (quanta - quanta * rectification), 1.0f, EnchantingStatRegistry.getAbsoluteMaxEterna() * 4.0f));
                final int maxPow = Math.round(Mth.m_14036_(level + level * quanta, 1.0f, EnchantingStatRegistry.getAbsoluteMaxEterna() * 4.0f));
                this.powers[i] = new int[] { minPow, maxPow };
                this.selectedSlot = i;
            }
        }
    }
    
    protected void m_7856_() {
        this.leftPos = (this.f_96543_ - this.imageWidth) / 2;
        this.topPos = (this.f_96544_ - this.imageHeight) / 2;
        this.slider = (PowerSlider)this.m_142416_((GuiEventListener)new PowerSlider(this.leftPos + 5, this.topPos + 80, 80, 20));
    }
    
    public void m_88315_(final GuiGraphics gfx, final int pMouseX, final int pMouseY, final float pPartialTick) {
        this.m_280273_(gfx);
        final PoseStack pose = gfx.m_280168_();
        pose.m_85836_();
        pose.m_252880_((float)this.leftPos, (float)this.topPos, 0.0f);
        gfx.m_280218_(EnchantingInfoScreen.TEXTURES, 0, 0, 0, 0, this.imageWidth, this.imageHeight);
        for (int i = 0; i < 3; ++i) {
            final Enchantment clue = Enchantment.m_44697_(this.clues[i]);
            int u = 199;
            int v = 225;
            if (clue == null) {
                u += 19;
                v += 16;
            }
            else if (this.selectedSlot == i || this.isHovering(8, 18 + 19 * i, 18, 18, pMouseX, pMouseY)) {
                u += 38;
            }
            gfx.m_280218_(EnchantingInfoScreen.TEXTURES, 8, 18 + 19 * i, 224, u, 18, 19);
            gfx.m_280218_(EnchantingInfoScreen.TEXTURES, 9, 22 + 18 * i + i, 16 * i, v, 16, 16);
        }
        final int scrollbarPos = (int)(128.0f * this.scrollOffs);
        gfx.m_280218_(EnchantingInfoScreen.TEXTURES, 220, 18 + scrollbarPos, 244, 173 + (this.isScrollBarActive() ? 0 : 15), 12, 15);
        final EnchantmentDataWrapper hover = this.getHovered(pMouseX, pMouseY);
        for (int j = 0; j < 11 && this.enchantments.size() - 1 >= j; ++j) {
            int v = 173;
            final EnchantmentDataWrapper data = this.enchantments.get(this.startIndex + j);
            if (data.isBlacklisted) {
                v += 26;
            }
            else if (hover == this.enchantments.get(this.startIndex + j)) {
                v += 13;
            }
            gfx.m_280218_(EnchantingInfoScreen.TEXTURES, 89, 18 + 13 * j, 96, v, 128, 13);
        }
        for (int j = 0; j < 11 && this.enchantments.size() - 1 >= j; ++j) {
            final EnchantmentDataWrapper data2 = this.enchantments.get(this.startIndex + j);
            if (data2.isBlacklisted) {
                gfx.m_280614_(this.f_96547_, (Component)Component.m_237115_(data2.getEnch().m_44704_()).m_130938_(s -> s.m_178520_(5812428).m_178522_(Boolean.valueOf(true))), 91, 21 + 13 * j, 16777088, false);
            }
            else {
                gfx.m_280056_(this.f_96547_, I18n.m_118938_(data2.getEnch().m_44704_(), new Object[0]), 91, 21 + 13 * j, 16777088, false);
            }
        }
        final List<Component> list = new ArrayList<Component>();
        final ApothEnchantmentMenu.Arcana a = ApothEnchantmentMenu.Arcana.getForThreshold(this.parent.getMenu().stats.arcana());
        list.add((Component)Component.m_237115_("info.apotheosis.weights").m_130944_(new ChatFormatting[] { ChatFormatting.UNDERLINE, ChatFormatting.YELLOW }));
        list.add((Component)Component.m_237110_("info.apotheosis.weight", new Object[] { I18n.m_118938_("rarity.enchantment.common", new Object[0]), a.rarities[0] }).m_130940_(ChatFormatting.GRAY));
        list.add((Component)Component.m_237110_("info.apotheosis.weight", new Object[] { I18n.m_118938_("rarity.enchantment.uncommon", new Object[0]), a.rarities[1] }).m_130940_(ChatFormatting.GREEN));
        list.add((Component)Component.m_237110_("info.apotheosis.weight", new Object[] { I18n.m_118938_("rarity.enchantment.rare", new Object[0]), a.rarities[2] }).m_130940_(ChatFormatting.BLUE));
        list.add((Component)Component.m_237110_("info.apotheosis.weight", new Object[] { I18n.m_118938_("rarity.enchantment.very_rare", new Object[0]), a.rarities[3] }).m_130940_(ChatFormatting.GOLD));
        gfx.m_280666_(this.f_96547_, (List)list, (a == ApothEnchantmentMenu.Arcana.MAX) ? -2 : 1, 120);
        gfx.m_280614_(this.f_96547_, this.f_96539_, 7, 4, 4210752, false);
        pose.m_85849_();
        pose.m_252880_(0.0f, 0.0f, 10.0f);
        for (int k = 0; k < 3; ++k) {
            if (this.isHovering(8, 18 + 19 * k, 18, 18, pMouseX, pMouseY)) {
                list.clear();
                list.add((Component)Component.m_237110_("info.apotheosis.enchinfo_slot", new Object[] { k + 1 }).m_130944_(new ChatFormatting[] { ChatFormatting.GOLD, ChatFormatting.UNDERLINE }));
                list.add((Component)Component.m_237110_("info.apotheosis.enchinfo_level", new Object[] { this.costs[k] }).m_130940_(ChatFormatting.GREEN));
                list.add((Component)Component.m_237110_("info.apotheosis.enchinfo_minpow", new Object[] { this.powers[k][0] }).m_130940_(ChatFormatting.DARK_RED));
                list.add((Component)Component.m_237110_("info.apotheosis.enchinfo_maxpow", new Object[] { this.powers[k][1] }).m_130940_(ChatFormatting.BLUE));
                gfx.m_280666_(this.f_96547_, (List)list, pMouseX, pMouseY);
            }
        }
        if (hover != null) {
            list.clear();
            list.add((Component)Component.m_237115_(hover.getEnch().m_44704_()).m_130944_(new ChatFormatting[] { getColor(hover.getEnch()), ChatFormatting.UNDERLINE }));
            list.add((Component)Component.m_237110_("info.apotheosis.enchinfo_level", new Object[] { Component.m_237115_("enchantment.level." + hover.getLevel()) }).m_130940_(ChatFormatting.DARK_AQUA));
            final Component rarity = (Component)Component.m_237115_("rarity.enchantment." + hover.getEnch().m_44699_().name().toLowerCase(Locale.ROOT)).m_130940_(EnchantingInfoScreen.colors[hover.getEnch().m_44699_().ordinal()]);
            list.add((Component)Component.m_237110_("info.apotheosis.enchinfo_rarity", new Object[] { rarity }).m_130940_(ChatFormatting.DARK_AQUA));
            list.add((Component)Component.m_237110_("info.apotheosis.enchinfo_chance", new Object[] { String.format("%.2f", 100.0f * hover.m_142631_().m_146281_() / WeightedRandom.m_146312_((List)this.enchantments)) }).m_130940_(ChatFormatting.DARK_AQUA));
            if (I18n.m_118936_(hover.getEnch().m_44704_() + ".desc")) {
                list.add((Component)Component.m_237115_(hover.getEnch().m_44704_() + ".desc").m_130940_(ChatFormatting.DARK_AQUA));
            }
            final List<Enchantment> excls = this.exclusions.get(hover.getEnch());
            if (!excls.isEmpty()) {
                final StringBuilder sb = new StringBuilder();
                for (int l = 0; l < excls.size(); ++l) {
                    sb.append(I18n.m_118938_(excls.get(l).m_44704_(), new Object[0]));
                    if (l != excls.size() - 1) {
                        sb.append(", ");
                    }
                }
                list.add((Component)Component.m_237110_("Exclusive With: %s", new Object[] { sb.toString() }).m_130940_(ChatFormatting.RED));
            }
            gfx.m_280666_(this.f_96547_, (List)list, pMouseX, pMouseY);
        }
        gfx.m_280203_(this.toEnchant, this.leftPos + 49, this.topPos + 39);
        pose.m_252880_(0.0f, 0.0f, -10.0f);
        super.m_88315_(gfx, pMouseX, pMouseY, pPartialTick);
    }
    
    public boolean m_6375_(final double pMouseX, final double pMouseY, final int pButton) {
        this.scrolling = false;
        final int left = this.leftPos + 220;
        final int top = this.topPos + 18;
        if (pMouseX >= left && pMouseX < left + 12 && pMouseY >= top && pMouseY < top + 143) {
            this.scrolling = true;
            this.m_7979_(pMouseX, pMouseY, 0, pMouseX, pMouseY);
        }
        for (int i = 0; i < 3; ++i) {
            final Enchantment clue = Enchantment.m_44697_(this.clues[i]);
            if (this.selectedSlot != i && clue != null && this.isHovering(8, 18 + 19 * i, 18, 18, pMouseX, pMouseY)) {
                this.selectedSlot = i;
                this.slider.setValue((this.slider.min() + this.slider.max()) / 2);
                Minecraft.m_91087_().m_91106_().m_120367_((SoundInstance)SimpleSoundInstance.m_263171_((Holder)SoundEvents.f_12490_, 1.0f));
                return true;
            }
        }
        return super.m_6375_(pMouseX, pMouseY, pButton);
    }
    
    public boolean m_7979_(final double pMouseX, final double pMouseY, final int pButton, final double pDragX, final double pDragY) {
        if (this.scrolling && this.isScrollBarActive()) {
            final int i = this.topPos + 18;
            final int j = i + 143;
            this.scrollOffs = ((float)pMouseY - i - 7.5f) / (j - i - 15.0f);
            this.scrollOffs = Mth.m_14036_(this.scrollOffs, 0.0f, 1.0f);
            this.startIndex = (int)(this.scrollOffs * this.getOffscreenRows() + 0.5);
            return true;
        }
        return super.m_7979_(pMouseX, pMouseY, pButton, pDragX, pDragY);
    }
    
    public boolean m_6050_(final double pMouseX, final double pMouseY, final double pDelta) {
        if (this.isScrollBarActive()) {
            final int i = this.getOffscreenRows();
            this.scrollOffs -= (float)(pDelta / i);
            this.scrollOffs = Mth.m_14036_(this.scrollOffs, 0.0f, 1.0f);
            this.startIndex = (int)(this.scrollOffs * i + 0.5);
        }
        return true;
    }
    
    private boolean isScrollBarActive() {
        return this.enchantments.size() > 11;
    }
    
    protected int getOffscreenRows() {
        return this.enchantments.size() - 11;
    }
    
    protected boolean isHovering(final int pX, final int pY, final int pWidth, final int pHeight, double pMouseX, double pMouseY) {
        final int i = this.leftPos;
        final int j = this.topPos;
        pMouseX -= i;
        pMouseY -= j;
        return pMouseX >= pX - 1 && pMouseX < pX + pWidth + 1 && pMouseY >= pY - 1 && pMouseY < pY + pHeight + 1;
    }
    
    protected void recomputeEnchantments() {
        final ApothEnchantmentMenu.Arcana arc = ApothEnchantmentMenu.Arcana.getForThreshold(this.parent.getMenu().stats.arcana());
        final Set<Enchantment> blacklist = this.parent.getMenu().stats.blacklist();
        this.enchantments = RealEnchantmentHelper.getAvailableEnchantmentResults(this.currentPower, this.toEnchant, this.treasure, Collections.emptySet()).stream().map(e -> new RealEnchantmentHelper.ArcanaEnchantmentData(arc, e)).map(a -> new EnchantmentDataWrapper(a, blacklist.contains(a.data.f_44947_))).collect((Collector<? super Object, ?, List<EnchantmentDataWrapper>>)Collectors.toList());
        if (this.startIndex + 11 >= this.enchantments.size()) {
            this.startIndex = 0;
            this.scrollOffs = 0.0f;
        }
        this.exclusions.clear();
        for (final EnchantmentDataWrapper d : this.enchantments) {
            if (blacklist.contains(d.getEnch())) {
                continue;
            }
            final List<Enchantment> excls = new ArrayList<Enchantment>();
            for (final EnchantmentDataWrapper d2 : this.enchantments) {
                if (d != d2 && !d.getEnch().m_44695_(d2.getEnch())) {
                    excls.add(d2.getEnch());
                }
            }
            this.exclusions.put(d.getEnch(), excls);
        }
    }
    
    public boolean m_7043_() {
        return false;
    }
    
    protected EnchantmentDataWrapper getHovered(final double mouseX, final double mouseY) {
        for (int i = 0; i < 11 && this.enchantments.size() - 1 >= i; ++i) {
            if (this.isHovering(89, 18 + i * 13, 128, 13, mouseX, mouseY)) {
                final EnchantmentDataWrapper data = this.enchantments.get(this.startIndex + i);
                return data.isBlacklisted ? null : data;
            }
        }
        return null;
    }
    
    public static ChatFormatting getColor(final Enchantment ench) {
        return EnchModule.getEnchInfo(ench).isTreasure() ? ChatFormatting.GOLD : ChatFormatting.GREEN;
    }
    
    static {
        TEXTURES = new ResourceLocation("apotheosis", "textures/gui/enchanting_info.png");
        EnchantingInfoScreen.colors = new ChatFormatting[] { ChatFormatting.WHITE, ChatFormatting.YELLOW, ChatFormatting.BLUE, ChatFormatting.GOLD };
    }
    
    public class PowerSlider extends AbstractSliderButton
    {
        public PowerSlider(final int x, final int y, final int width, final int height) {
            super(x, y, width, height, (Component)Component.m_237119_(), 0.0);
            if (EnchantingInfoScreen.this.selectedSlot != -1 && this.f_93577_ == 0.0) {
                this.f_93577_ = this.normalizeValue((EnchantingInfoScreen.this.currentPower == 0) ? ((double)((this.max() + this.min()) / 2)) : ((double)EnchantingInfoScreen.this.currentPower));
                this.m_5697_();
            }
            this.m_5695_();
        }
        
        protected void m_5695_() {
            this.m_93666_((Component)Component.m_237110_("info.apotheosis.slider_power", new Object[] { EnchantingInfoScreen.this.currentPower }));
        }
        
        protected void m_5697_() {
            EnchantingInfoScreen.this.currentPower = this.denormalizeValue(this.f_93577_);
            EnchantingInfoScreen.this.recomputeEnchantments();
        }
        
        public void setValue(final int value) {
            if (!EnchantingInfoScreen.this.m_7282_()) {
                this.f_93577_ = this.normalizeValue(value);
                this.m_5697_();
                this.m_5695_();
            }
        }
        
        public double normalizeValue(final double value) {
            return Mth.m_14008_((this.snapToStepClamp(value) - this.min()) / (this.max() - this.min()), 0.0, 1.0);
        }
        
        public int denormalizeValue(final double value) {
            return (int)this.snapToStepClamp(Mth.m_14139_(Mth.m_14008_(value, 0.0, 1.0), (double)this.min(), (double)this.max()));
        }
        
        private double snapToStepClamp(double valueIn) {
            if (this.step() > 0.0f) {
                valueIn = this.step() * Math.round(valueIn / this.step());
            }
            return Mth.m_14008_(valueIn, (double)this.min(), (double)this.max());
        }
        
        private int min() {
            return EnchantingInfoScreen.this.powers[EnchantingInfoScreen.this.selectedSlot][0];
        }
        
        private int max() {
            return EnchantingInfoScreen.this.powers[EnchantingInfoScreen.this.selectedSlot][1];
        }
        
        private float step() {
            return 1.0f / Math.max(this.max() - this.min(), 1);
        }
    }
    
    protected static class EnchantmentDataWrapper extends WeightedEntry.IntrusiveBase
    {
        protected final RealEnchantmentHelper.ArcanaEnchantmentData data;
        protected final boolean isBlacklisted;
        
        public EnchantmentDataWrapper(final RealEnchantmentHelper.ArcanaEnchantmentData data, final boolean isBlacklisted) {
            super(isBlacklisted ? 0 : data.m_142631_().m_146281_());
            this.data = data;
            this.isBlacklisted = isBlacklisted;
        }
        
        public Enchantment getEnch() {
            return this.data.data.f_44947_;
        }
        
        public int getLevel() {
            return this.data.data.f_44948_;
        }
    }
}
